Library.LibRowdy.Setup(...);

package "string";

strupper = _G.string.upper;
strlower = _G.string.lower;
strsplit = _G.string.split;
strlen = _G.string.len;
strmatch = _G.string.match;
strsub = _G.string.sub;

function strtrim(s)
  -- from PiL2 20.4
  return (s:gsub("^%s*(.-)%s*$", "%1"))
end

-- remove leading whitespace from string.
-- http://en.wikipedia.org/wiki/Trim_(8programming)
function strtrimstart(s)
  return (s:gsub("^%s*", ""))
end

-- remove trailing whitespace from string.
-- http://en.wikipedia.org/wiki/Trim_(8programming)
function strtrimend(s)
  local n = #s
  while n > 0 and s:find("^%s", n) do n = n - 1 end
  return s:sub(1, n)
end

function strstartswith(string, value)
   return value == '' or strsub(string, 1, strlen(value)) == value;
end

function strendswith(string, value)
   return value == '' or strsub(string, -string.len(value)) == value;
end