Library.LibRowdy.Setup(...);

import "core";

package "table";

tinsert = _G.table.insert;
tremove = _G.table.remove;
tsort = _G.table.sort;

tcontains = function(table, what)
	for k, v in pairs(table) do
		if (v == what) then
			return true;
		end
	end

	return false;
end

tremovekey = function(table, key)
	if (type(key) == "number" and key > 0 and key <= #table) then
		tremove(table, key);
	else
		table[key] = nil;
	end
end

tremovevalue = function(table, value)
	for k, v in pairs(table) do
		if (v == value) then
			tremovekey(table, k);
		end
	end
end

tremovewhere = function(table, where)
	for k, v in pairs(table) do
		if (where(k, v)) then
			tremovekey(table, k);
		end
	end
end

tclear = function(table)
	local index = nil
	while (true) do
		index = next(table);

		if (index == nil) then
			break
		end

		tremovekey(table, index);
	end
end

tpop = function(table)
	local length = #table;
	if (length <= 0) then
		return nil;
	end

	local value = table[length];
	tremove(table, length);
	return value;
end