Library.LibRowdy.Setup(...);

import "core";
import "string";
import "event";
import "class";

package "ui";

--[[
	Framed frame
]]
do
	local base, metatable, methods = nil, nil, { };

	-- public members
	methods.SetBackgroundColor = function(self, r, g, b, a)
		base.SetBackgroundColor(self, r, g, b, a);
		self[UI.FramedFrame].inner:SetBackgroundColor(r, g, b, a);
	end
	
	methods.SetBorderColor = function(self, r, g, b, a)
		self[UI.FramedFrame].border:SetBackgroundColor(r, g, b, a);
	end
	
	methods.GetBorderColor = function(self)
		return self[UI.FramedFrame].border:GetBackgroundColor();
	end

	-- constructor
	UI.FramedFrame = function(name, parent)
		assert(type(name) == "string", "UI.FramedFrame requires 'name' (string) parameter");
		assert(isInstanceOf(parent, UI.Context) or isInstanceOf(parent, UI.FrameBase),
			"UI.FramedFrame requires 'parent' (UI.Context or UI.FrameBase) parameter");

		local self = UI.Frame(name, parent);
		
		local border = UI.Frame(name .. "Border", self);
		border:SetPoint("TOPLEFT", self, "TOPLEFT", 1, 1);
		border:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -1, -1);
		border:SetLayer(-1);
		
		local inner = UI.Frame(name .. "Background", border);
		inner:SetPoint("TOPLEFT", border, "TOPLEFT", 1, 1);
		inner:SetPoint("BOTTOMRIGHT", border, "BOTTOMRIGHT", -1, -1);
		
		self[UI.FramedFrame] = {
			border = border,
			inner = inner
		};
		
		base, metatable = class(base, metatable, methods, self, UI.FramedFrame);

		self:SetBackgroundColor(.05, .05, .05, 1);
		self:SetBorderColor(.48, .18, .08, 1);

		return self;
	end
end