Library.LibRowdy.Setup(...);

import "core";
import "string";
import "event";
import "class";

package "ui";

--[[
	Framed text
]]
do
	local base, metatable, methods = nil, nil, { };

	-- public members
	methods.SetText = function(self, text)
		local frame = self[UI.FramedText].text;
	
		frame:SetText(text);
		frame:ResizeToText();
		
		self:SetWidth(frame:GetWidth() + 20);
		self:SetHeight(frame:GetHeight() + 10);
	end
	
	methods.GetText = function(self)
		return self[UI.FramedText].text:GetText();
	end

	methods.SetFontSize = function(self, size)
		self[UI.FramedText].text:SetFontSize(size);
	end

	-- constructor
	UI.FramedText = function(name, parent)
		assert(type(name) == "string", "UI.FramedText requires 'name' (string) parameter");
		assert(isInstanceOf(parent, UI.Context) or isInstanceOf(parent, UI.FrameBase),
			"UI.FramedText requires 'parent' (UI.Context or UI.FrameBase) parameter");
	
		local self = UI.FramedFrame(name, parent);
		
		local text = UI.Text(name .. "Text", self);
		text:SetPoint("CENTER", self, "CENTER", 0, 0);
	
		self[UI.FramedText] = {
			text = text
		};
		
		base, metatable = class(base, metatable, methods, self, UI.FramedText);

		return self;
	end
end